Index: pjproject/trunk/Makefile
===================================================================
--- pjproject/trunk/Makefile	(revision 2505)
+++ pjproject/trunk/Makefile	(revision 2506)
@@ -34,4 +34,5 @@
 	pjnath/lib/libpjnath-$(TARGET_NAME).a \
 	pjmedia/lib/libpjmedia-$(TARGET_NAME).a \
+	pjmedia/lib/libpjmedia-audiodev-$(TARGET_NAME).a \
 	pjmedia/lib/libpjmedia-codec-$(TARGET_NAME).a \
        	pjsip/lib/libpjsip-$(TARGET_NAME).a \
Index: pjproject/trunk/build.mak.in
===================================================================
--- pjproject/trunk/build.mak.in	(revision 2505)
+++ pjproject/trunk/build.mak.in	(revision 2506)
@@ -61,4 +61,5 @@
 	-lpjmedia-codec-$(TARGET_NAME)\
 	-lpjmedia-$(TARGET_NAME)\
+	-lpjmedia-audiodev-$(TARGET_NAME)\
 	-lpjnath-$(TARGET_NAME)\
 	-lpjlib-util-$(TARGET_NAME)\
Index: pjproject/trunk/build.symbian/bld.inf
===================================================================
--- pjproject/trunk/build.symbian/bld.inf	(revision 2505)
+++ pjproject/trunk/build.symbian/bld.inf	(revision 2506)
@@ -1,5 +1,2 @@
-#define SND_USE_NULL	0
-#define SND_USE_APS	0
-
 prj_platforms
 winscw
@@ -24,13 +21,8 @@
 libgsmcodec.mmp
 libspeexcodec.mmp
+libpassthroughcodec.mmp
 
-/* Sound device impl */
-#if SND_USE_NULL
-	null_audio.mmp
-#elif SND_USE_APS
-	symbian_audio_aps.mmp
-#else
-	symbian_audio.mmp
-#endif
+/* Audio device. */
+pjmedia_audiodev.mmp
 
 /* Applications */
Index: pjproject/trunk/build.symbian/libpassthroughcodec.mmp
===================================================================
--- pjproject/trunk/build.symbian/libpassthroughcodec.mmp	(revision 2506)
+++ pjproject/trunk/build.symbian/libpassthroughcodec.mmp	(revision 2506)
@@ -0,0 +1,26 @@
+TARGET		libpassthroughcodec.lib
+TARGETTYPE	lib
+
+MACRO		HAVE_CONFIG_H
+MACRO		PJ_M_I386=1
+MACRO		PJ_SYMBIAN=1
+
+//
+// GCCE optimization setting
+//
+OPTION		GCCE -O2 -fno-unit-at-a-time
+
+//
+// Passthrough codecs wrapper for pjmedia-codec
+//
+SOURCEPATH 	..\pjmedia\src\pjmedia-codec
+SOURCE		passthrough.c
+
+//
+// Header files
+//
+SYSTEMINCLUDE	..\pjmedia\include
+SYSTEMINCLUDE	..\pjlib\include 
+
+SYSTEMINCLUDE	\epoc32\include 
+SYSTEMINCLUDE	\epoc32\include\libc
Index: pjproject/trunk/build.symbian/pjlib.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjlib.mmp	(revision 2505)
+++ pjproject/trunk/build.symbian/pjlib.mmp	(revision 2506)
@@ -19,8 +19,4 @@
 
 SOURCEPATH	..\pjlib\src\pj
-
-OPTION		CW -lang c++
-OPTION		ARMCC --cpp
-OPTION		GCC	-x c++
 
 MACRO		PJ_M_I386=1
Index: pjproject/trunk/build.symbian/pjlib_test.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjlib_test.mmp	(revision 2505)
+++ pjproject/trunk/build.symbian/pjlib_test.mmp	(revision 2506)
@@ -15,8 +15,4 @@
 STATICLIBRARY	pjlib.lib 
 #endif
-
-OPTION		CW -lang c++
-OPTION		ARMCC --cpp
-OPTION		GCC	-x c++
 
 // Test files
Index: pjproject/trunk/build.symbian/pjlib_util.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjlib_util.mmp	(revision 2505)
+++ pjproject/trunk/build.symbian/pjlib_util.mmp	(revision 2506)
@@ -22,8 +22,4 @@
 MACRO		PJ_M_I386=1
 MACRO		PJ_SYMBIAN=1
-
-OPTION		CW -lang c++
-OPTION		ARMCC --cpp
-OPTION		GCC	-x c++
 
 //
Index: pjproject/trunk/build.symbian/pjmedia.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjmedia.mmp	(revision 2505)
+++ pjproject/trunk/build.symbian/pjmedia.mmp	(revision 2506)
@@ -41,4 +41,5 @@
 SOURCE		codec.c
 SOURCE		conference.c
+SOURCE		conf_switch.c
 SOURCE		echo_common.c
 SOURCE		echo_port.c
Index: pjproject/trunk/build.symbian/pjmedia_audiodev.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjmedia_audiodev.mmp	(revision 2506)
+++ pjproject/trunk/build.symbian/pjmedia_audiodev.mmp	(revision 2506)
@@ -0,0 +1,30 @@
+TARGET 		pjmedia_audiodev.lib
+TARGETTYPE 	lib
+
+SOURCEPATH	..\pjmedia\src\pjmedia-audiodev
+
+//
+// GCCE optimization setting
+//
+//OPTION		GCCE -O2 -fno-unit-at-a-time
+
+MACRO		PJ_M_I386=1
+MACRO		PJ_SYMBIAN=1
+
+SOURCE		audiodev.c
+SOURCE		errno.c
+SOURCE		symb_aps_dev.cpp
+SOURCE		symb_mda_dev.cpp
+
+SYSTEMINCLUDE	..\pjmedia\include
+SYSTEMINCLUDE	..\pjlib\include 
+SYSTEMINCLUDE	..\pjlib-util\include 
+
+SYSTEMINCLUDE	\epoc32\include
+SYSTEMINCLUDE	\epoc32\include\libc
+SYSTEMINCLUDE   \epoc32\include\mmf\server 
+SYSTEMINCLUDE   \epoc32\include\mmf\common 
+SYSTEMINCLUDE   \epoc32\include\mda\common 
+SYSTEMINCLUDE	\epoc32\include\mmf\plugin 
+
+
Index: pjproject/trunk/build.symbian/pjnath.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjnath.mmp	(revision 2505)
+++ pjproject/trunk/build.symbian/pjnath.mmp	(revision 2506)
@@ -22,8 +22,4 @@
 MACRO		PJ_M_I386=1
 MACRO		PJ_SYMBIAN=1
-
-OPTION		CW -lang c++
-OPTION		ARMCC --cpp
-OPTION		GCC	-x c++
 
 //
Index: pjproject/trunk/build.symbian/pjsdp.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjsdp.mmp	(revision 2505)
+++ pjproject/trunk/build.symbian/pjsdp.mmp	(revision 2506)
@@ -20,8 +20,4 @@
 SOURCEPATH	..\pjmedia\src\pjmedia
 
-OPTION		CW -lang c++
-OPTION		ARMCC --cpp
-OPTION		GCC	-x c++
-
 MACRO		PJ_M_I386=1
 MACRO		PJ_SYMBIAN=1
Index: pjproject/trunk/build.symbian/pjsip.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjsip.mmp	(revision 2505)
+++ pjproject/trunk/build.symbian/pjsip.mmp	(revision 2506)
@@ -25,8 +25,4 @@
 MACRO		PJ_M_I386=1
 MACRO		PJ_SYMBIAN=1
-
-OPTION		CW -lang c++
-OPTION		ARMCC --cpp
-OPTION		GCC	-x c++
 
 // PJSIP-CORE files
Index: pjproject/trunk/build.symbian/pjsip_simple.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjsip_simple.mmp	(revision 2505)
+++ pjproject/trunk/build.symbian/pjsip_simple.mmp	(revision 2506)
@@ -26,9 +26,4 @@
 MACRO		PJ_SYMBIAN=1
 
-OPTION		CW -lang c++
-OPTION		ARMCC --cpp
-OPTION		GCC	-x c++
-
-
 // PJSIP-SIMPLE files
 
Index: pjproject/trunk/build.symbian/pjstun_client.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjstun_client.mmp	(revision 2505)
+++ pjproject/trunk/build.symbian/pjstun_client.mmp	(revision 2506)
@@ -7,8 +7,4 @@
 MACRO		PJ_M_I386=1
 MACRO		PJ_SYMBIAN=1
-
-OPTION		CW -lang c++
-OPTION		ARMCC --cpp
-OPTION		GCC	-x c++
 
 // PJSTUN-CLIENT files
Index: pjproject/trunk/build.symbian/symbian_audio.mmp
===================================================================
--- pjproject/trunk/build.symbian/symbian_audio.mmp	(revision 2505)
+++ pjproject/trunk/build.symbian/symbian_audio.mmp	(revision 2506)
@@ -25,8 +25,4 @@
 
 OPTION		CW -lang c++
-
-//
-// GCCE optimization setting
-//
 OPTION		GCCE -O2 -fno-unit-at-a-time
 
@@ -34,5 +30,7 @@
 MACRO		PJ_SYMBIAN=1
 
+SOURCE		nullsound.c
 SOURCE		symbian_sound.cpp
+SOURCE		symbian_sound_aps.cpp
 
 SYSTEMINCLUDE	..\pjlib\include
@@ -41,4 +39,7 @@
 SYSTEMINCLUDE	\epoc32\include
 SYSTEMINCLUDE	\epoc32\include\libc
+SYSTEMINCLUDE   \epoc32\include\mmf\server 
+SYSTEMINCLUDE   \epoc32\include\mmf\common 
+SYSTEMINCLUDE   \epoc32\include\mda\common 
 
 SYSTEMINCLUDE	\epoc32\include\mmf\plugin 
Index: pjproject/trunk/build.symbian/symbian_ua.mmp
===================================================================
--- pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 2505)
+++ pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 2506)
@@ -1,63 +1,70 @@
-#define SND_USE_NULL	0
-#define SND_USE_APS	0
+#define SND_HAS_APS	0
+#define SND_HAS_VAS	0
+#define SND_HAS_MDA	1
 
-TARGET 		symbian_ua.exe
-TARGETTYPE 	exe
-UID		0x0 0xA000000D
+TARGET 			symbian_ua.exe
+TARGETTYPE 		exe
+UID			0x0 0x200235D3
 
-SOURCEPATH	..\pjsip-apps\src\symbian_ua
+SOURCEPATH		..\pjsip-apps\src\symbian_ua
 
-MACRO		PJ_M_I386=1
-MACRO		PJ_SYMBIAN=1
+MACRO			PJ_M_I386=1
+MACRO			PJ_SYMBIAN=1
 
 // Source files
 
-SOURCE	ua.cpp
-SOURCE	main_symbian.cpp
+SOURCE			ua.cpp
+SOURCE			main_symbian.cpp
 
-DOCUMENT ua.h
+DOCUMENT 		ua.h
 
-START RESOURCE  symbian_ua_reg.rss
+START RESOURCE  	symbian_ua_reg.rss
 	TARGETPATH      \private\10003a3f\apps
 END
 
-SYSTEMINCLUDE	..\pjlib\include
-SYSTEMINCLUDE	..\pjlib-util\include
-SYSTEMINCLUDE	..\pjnath\include
-SYSTEMINCLUDE	..\pjmedia\include
-SYSTEMINCLUDE	..\pjsip\include
+SYSTEMINCLUDE		..\pjlib\include
+SYSTEMINCLUDE		..\pjlib-util\include
+SYSTEMINCLUDE		..\pjnath\include
+SYSTEMINCLUDE		..\pjmedia\include
+SYSTEMINCLUDE		..\pjsip\include
 
-SYSTEMINCLUDE	\epoc32\include
-SYSTEMINCLUDE	\epoc32\include\libc
+SYSTEMINCLUDE		\epoc32\include
+SYSTEMINCLUDE		\epoc32\include\libc
 
-STATICLIBRARY	pjsua_lib.lib pjsip_ua.lib
-STATICLIBRARY	pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib
-STATICLIBRARY	pjnath.lib pjlib_util.lib pjlib.lib
-STATICLIBRARY	libsrtp.lib
-STATICLIBRARY	libgsmcodec.lib libspeexcodec.lib
+STATICLIBRARY		pjsua_lib.lib pjsip_ua.lib
+STATICLIBRARY		pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib
+STATICLIBRARY		pjnath.lib pjlib_util.lib pjlib.lib
+STATICLIBRARY		libsrtp.lib
+STATICLIBRARY		libgsmcodec.lib libspeexcodec.lib
+STATICLIBRARY		libpassthroughcodec.lib
+STATICLIBRARY		pjmedia_audiodev.lib 
 
-#if SND_USE_NULL
-    STATICLIBRARY	null_audio.lib
-    CAPABILITY		NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment 
-#elif SND_USE_APS
-    STATICLIBRARY	symbian_audio_aps.lib
-    LIBRARY		APSSession2.lib
-    CAPABILITY		NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment MultimediaDD
-    MACRO		PJMEDIA_SYM_SND_USE_APS=1
-#else
-    STATICLIBRARY	symbian_audio.lib
-    LIBRARY 		mediaclientaudiostream.lib
-    LIBRARY 		mediaclientaudioinputstream.lib
-    CAPABILITY		NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment 
+#if SND_HAS_APS
+	LIBRARY		APSSession2.lib
 #endif
 
+#if SND_HAS_VAS
+//	LIBRARY		
+#endif
+
+#if SND_HAS_MDA
+	LIBRARY 	mediaclientaudiostream.lib
+	LIBRARY 	mediaclientaudioinputstream.lib
+#endif
+
+#if SND_HAS_APS || SND_HAS_VAS
+	CAPABILITY	NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment MultimediaDD
+#else
+	CAPABILITY	NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment
+#endif
+	
 #ifdef WINSCW
 	STATICLIBRARY   eexe.lib ecrt0.lib
 #endif
 
-LIBRARY		esock.lib insock.lib charconv.lib euser.lib estlib.lib commdb.lib apengine.lib 
+LIBRARY			esock.lib insock.lib charconv.lib euser.lib estlib.lib commdb.lib apengine.lib 
 
 // The default 8KB seems to be insufficient with all bells and
 // whistles turned on
-EPOCSTACKSIZE	12288
+EPOCSTACKSIZE		12288
 
Index: pjproject/trunk/build.symbian/symbian_ua.pkg
===================================================================
--- pjproject/trunk/build.symbian/symbian_ua.pkg	(revision 2506)
+++ pjproject/trunk/build.symbian/symbian_ua.pkg	(revision 2506)
@@ -0,0 +1,18 @@
+; symbian_ua.pkg
+
+; Languages
+&EN
+
+; Header
+#{"symbian_ua"},(0x200235D3), 0, 1, 1
+
+; Platform compatibility
+[0x101F7961], *, *, *,{"Series60ProductID"}
+
+; vendor
+%{"PJSIP"}
+:"PJSIP"
+
+; Target
+"$(EPOCROOT)Epoc32\release\$(PLATFORM)\$(TARGET)\symbian_ua.exe"-"!:\sys\bin\symbian_ua.exe"
+"$(EPOCROOT)Epoc32\data\z\private\10003a3f\apps\symbian_ua_reg.rSC"-"!:\private\10003a3f\import\apps\symbian_ua_reg.rSC"
Index: pjproject/trunk/build.symbian/symbian_ua_udeb.pkg
===================================================================
--- pjproject/trunk/build.symbian/symbian_ua_udeb.pkg	(revision 2505)
+++ pjproject/trunk/build.symbian/symbian_ua_udeb.pkg	(revision 2506)
@@ -1,3 +1,6 @@
-; symbian_ua.pkg
+; symbian_ua_udeb.pkg
+
+; for Carbide development, please use symbian_ua.pkg for comfortness
+; (epoc32 path, platform, and target are set automatically using env vars)
 
 ; Languages
@@ -5,5 +8,5 @@
 
 ; Header
-#{"symbian_ua"},(0xA000000D), 0, 1, 1
+#{"symbian_ua"},(0x200235D3), 0, 1, 1
 
 ; Platform compatibility
@@ -15,4 +18,4 @@
 
 ; Target
-"C:\Symbian\9.1\S60_3rd_MR\epoc32\release\gcce\UDEB\symbian_ua.exe"-"!:\sys\bin\symbian_ua.exe"
-"C:\Symbian\9.1\S60_3rd_MR\epoc32\data\z\private\10003a3f\apps\symbian_ua_reg.rSC"-"!:\private\10003a3f\import\apps\symbian_ua_reg.rSC"
+"C:\Symbian\9.2\S60_3rd_FP1\epoc32\release\gcce\UDEB\symbian_ua.exe"-"!:\sys\bin\symbian_ua.exe"
+"C:\Symbian\9.2\S60_3rd_FP1\epoc32\data\z\private\10003a3f\apps\symbian_ua_reg.rSC"-"!:\private\10003a3f\import\apps\symbian_ua_reg.rSC"
Index: pjproject/trunk/build.symbian/symbian_ua_urel.pkg
===================================================================
--- pjproject/trunk/build.symbian/symbian_ua_urel.pkg	(revision 2505)
+++ pjproject/trunk/build.symbian/symbian_ua_urel.pkg	(revision 2506)
@@ -1,3 +1,6 @@
 ; symbian_ua.pkg
+
+; for Carbide development, please use symbian_ua.pkg for comfortness
+; (epoc32 path, platform, and target are set automatically using env vars)
 
 ; Languages
@@ -5,5 +8,5 @@
 
 ; Header
-#{"symbian_ua"},(0xA000000D), 0, 1, 1
+#{"symbian_ua"},(0x200235D3), 0, 1, 1
 
 ; Platform compatibility
Index: pjproject/trunk/build.symbian/symsndtest.mmp
===================================================================
--- pjproject/trunk/build.symbian/symsndtest.mmp	(revision 2505)
+++ pjproject/trunk/build.symbian/symsndtest.mmp	(revision 2506)
@@ -1,52 +1,44 @@
-#define SND_USE_NULL	0
-#define SND_USE_APS	0
+#define SND_USE_APS	1
+#define SND_USE_VAS	0
 
-TARGET 		symsndtest.exe
-TARGETTYPE 	exe
-UID		0x0 0xA000000E
+TARGET 			symsndtest.exe
+TARGETTYPE 		exe
+UID			0x0 0xA000000E
 
-SOURCEPATH	..\pjsip-apps\src\symsndtest
+SOURCEPATH		..\pjsip-apps\src\symsndtest
 
-MACRO		PJ_M_I386=1
-MACRO		PJ_SYMBIAN=1
+MACRO			PJ_M_I386=1
+MACRO			PJ_SYMBIAN=1
 
 // Test files
 
-SOURCE	app_main.cpp
-SOURCE	main_symbian.cpp
+SOURCE			app_main.cpp
+SOURCE			main_symbian.cpp
 
-START RESOURCE  symsndtest_reg.rss
+START RESOURCE  	symsndtest_reg.rss
 	TARGETPATH	\private\10003a3f\apps
 END
 
-SYSTEMINCLUDE	..\pjlib\include
-SYSTEMINCLUDE	..\pjmedia\include
+SYSTEMINCLUDE		..\pjlib\include
+SYSTEMINCLUDE		..\pjmedia\include
 
-SYSTEMINCLUDE	\epoc32\include
-SYSTEMINCLUDE	\epoc32\include\libc
+SYSTEMINCLUDE		\epoc32\include
+SYSTEMINCLUDE		\epoc32\include\libc
 
-LIBRARY		charconv.lib euser.lib estlib.lib
-LIBRARY		esock.lib insock.lib
-STATICLIBRARY	pjlib.lib pjmedia.lib
+LIBRARY			charconv.lib euser.lib estlib.lib
+LIBRARY			esock.lib insock.lib
+STATICLIBRARY		pjlib.lib pjmedia.lib
+STATICLIBRARY		symbian_audio.lib
 
-#if SND_USE_NULL
-    STATICLIBRARY	null_audio.lib
-    CAPABILITY		NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment 
-#elif SND_USE_APS
-    SOURCEPATH                              ..\pjmedia\src\pjmedia 
-    SOURCE                                  symbian_sound_aps.cpp 
-
-    SYSTEMINCLUDE                           \epoc32\include\mmf\server 
-    SYSTEMINCLUDE                           \epoc32\include\mmf\common 
-    SYSTEMINCLUDE                           \epoc32\include\mda\common 
-
-    //STATICLIBRARY	symbian_audio_aps.lib
-    LIBRARY		APSSession2.lib
-    CAPABILITY		NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment MultimediaDD
+#if SND_USE_APS
+	LIBRARY		APSSession2.lib
+	CAPABILITY	NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment MultimediaDD
+#elif SND_USE_VAS
+//	LIBRARY		
+	CAPABILITY	NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment MultimediaDD
 #else
-    STATICLIBRARY	symbian_audio.lib
-    LIBRARY 		mediaclientaudiostream.lib
-    LIBRARY 		mediaclientaudioinputstream.lib
-    CAPABILITY		NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment 
+	LIBRARY 	mediaclientaudiostream.lib
+	LIBRARY 	mediaclientaudioinputstream.lib
+	CAPABILITY	NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment
 #endif
 
Index: pjproject/trunk/pjlib/include/pj/compat/os_symbian.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/os_symbian.h	(revision 2505)
+++ pjproject/trunk/pjlib/include/pj/compat/os_symbian.h	(revision 2506)
@@ -115,5 +115,5 @@
  * Override features.
  */
-#define PJ_HAS_FLOATING_POINT	    1
+#define PJ_HAS_FLOATING_POINT	    0
 #define PJ_HAS_MALLOC               0
 #define PJ_HAS_SEMAPHORE	    1
Index: pjproject/trunk/pjlib/include/pj/config_site_sample.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 2505)
+++ pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 2506)
@@ -1,11 +1,21 @@
-
-
-//#define PJ_CONFIG_MINIMAL_SIZE
-//#define PJ_CONFIG_MAXIMUM_SPEED
-
-
-/*
- * This file (config_site_sample.h) contains various configuration
- * settings that I use for certain settings. 
+/*
+ * This file contains several sample settings especially for Windows
+ * Mobile and Symbian targets. You can include this file in your
+ * <pj/config_site.h> file.
+ *
+ * The Windows Mobile and Symbian settings will be activated
+ * automatically if you include this file.
+ *
+ * In addition, you may specify one of these macros (before including
+ * this file) to activate additional settings:
+ *
+ * #define PJ_CONFIG_NOKIA_APS_DIRECT
+ *   Use this macro to activate the APS-Direct feature. Please see
+ *   http://trac.pjsip.org/repos/wiki/Nokia_APS_VAS_Direct for more 
+ *   info.
+ *
+ * #define PJ_CONFIG_WIN32_WMME_DIRECT
+ *   Configuration to activate "APS-Direct" media mode on Windows or
+ *   Windows Mobile, useful for testing purposes only.
  */
 
@@ -15,24 +25,61 @@
  */
 #if defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE!=0
-#   define PJ_HAS_FLOATING_POINT	0
-
-#   define PJMEDIA_HAS_G711_PLC		0
-//#   define PJMEDIA_HAS_SMALL_FILTER	1
-//#   define PJMEDIA_HAS_LARGE_FILTER	0
-#   define PJMEDIA_HAS_L16_CODEC	0
-/*#   define PJMEDIA_HAS_GSM_CODEC	0*/
-/*#   define PJMEDIA_HAS_ILBC_CODEC	0*/
-/*#   define PJMEDIA_HAS_SPEEX_CODEC	0*/
-#   define PJMEDIA_HAS_SPEEX_AEC	0
-#   undef PJMEDIA_RESAMPLE_IMP
-#   define PJMEDIA_RESAMPLE_IMP		PJMEDIA_RESAMPLE_LIBRESAMPLE
-#   define PJMEDIA_WSOLA_IMP		PJMEDIA_WSOLA_IMP_WSOLA_LITE
-
-    /* Speex default quality settings */
-#   define PJSUA_DEFAULT_CODEC_QUALITY	5
-#   define PJMEDIA_CODEC_SPEEX_DEFAULT_QUALITY	5
-
-#   define PJMEDIA_SDP_NEG_PREFER_REMOTE_CODEC_ORDER	0
-#endif
+
+    /*
+     * PJLIB settings.
+     */
+
+    /* Disable floating point support */
+    #define PJ_HAS_FLOATING_POINT		0
+
+    /*
+     * PJMEDIA settings
+     */
+
+    /* Select codecs to disable */
+    #define PJMEDIA_HAS_L16_CODEC		0
+    #define PJMEDIA_HAS_ILBC_CODEC		0
+
+    /* We probably need more buffers on WM, so increase the limit */
+    #define PJMEDIA_SOUND_BUFFER_COUNT		32
+
+    /* Fine tune Speex's default settings for best performance/quality */
+    #define PJMEDIA_CODEC_SPEEX_DEFAULT_QUALITY	5
+
+    /* For CPU reason, disable speex AEC and use the echo suppressor. */
+    #define PJMEDIA_HAS_SPEEX_AEC		0
+
+    /* Shouldn't use resampling for performance reason too. */
+    #define PJMEDIA_RESAMPLE_IMP		PJMEDIA_RESAMPLE_NONE
+
+    /* Use the lighter WSOLA implementation */
+    #define PJMEDIA_WSOLA_IMP			PJMEDIA_WSOLA_IMP_WSOLA_LITE
+
+    /*
+     * PJSIP settings.
+     */
+
+    /* Set maximum number of dialog/transaction/calls to minimum to reduce
+     * memory usage 
+     */
+    #define PJSIP_MAX_TSX_COUNT 		31
+    #define PJSIP_MAX_DIALOG_COUNT 		31
+    #define PJSUA_MAX_CALLS			4
+
+    /*
+     * PJSUA settings
+     */
+
+    /* Default codec (Speex) quality */
+    #define PJSUA_DEFAULT_CODEC_QUALITY		5
+
+    /* Set maximum number of objects to minimum to reduce memory usage */
+    #define PJSUA_MAX_ACC			4
+    #define PJSUA_MAX_PLAYERS			4
+    #define PJSUA_MAX_RECORDERS			4
+    #define PJSUA_MAX_CONF_PORTS		(PJSUA_MAX_CALLS+2*PJSUA_MAX_PLAYERS)
+    #define PJSUA_MAX_BUDDIES			32
+
+#endif	/* PJ_WIN32_WINCE */
 
 
@@ -42,35 +89,13 @@
 #if defined(PJ_SYMBIAN) && PJ_SYMBIAN!=0
 
-    /* We don't want to use float, for now */
-#   undef PJ_HAS_FLOATING_POINT
-#   define PJ_HAS_FLOATING_POINT	0
-
-#   define PJMEDIA_SOUND_IMPLEMENTATION PJMEDIA_SOUND_NULL_SOUND
+    /*
+     * PJLIB settings.
+     */
+
+    /* Disable floating point support */
+    #define PJ_HAS_FLOATING_POINT		0
 
     /* Misc PJLIB setting */
-#   define PJ_MAXPATH			80
-
-	/* SRTP has not been ported to Symbian yet */
-#   define PJMEDIA_HAS_SRTP			1
-
-    /* Disable these */
-#   define PJMEDIA_RESAMPLE_IMP		PJMEDIA_RESAMPLE_NONE
-#   define PJMEDIA_HAS_SPEEX_AEC	0
-#   define PJMEDIA_WSOLA_IMP		PJMEDIA_WSOLA_IMP_WSOLA_LITE
-
-    /* Disable all codecs but G.711 and GSM, for now */
-#   define PJMEDIA_HAS_GSM_CODEC	1
-#   define PJMEDIA_HAS_L16_CODEC	0
-#   define PJMEDIA_HAS_ILBC_CODEC	0
-#   define PJMEDIA_HAS_SPEEX_CODEC	1
-#   define PJMEDIA_HAS_G722_CODEC	0
-
-    /* Need larger sound buffers */
-#   define PJMEDIA_SOUND_BUFFER_COUNT	16
-
-    /* Disable safe module access */
-#   define PJSIP_SAFE_MODULE		0
-
-#   define PJSIP_MAX_PKT_LEN		2000
+    #define PJ_MAXPATH				80
 
     /* This is important for Symbian. Symbian lacks vsnprintf(), so
@@ -79,42 +104,141 @@
      * to log the packet.
      */
-#   define PJ_LOG_MAX_SIZE		(PJSIP_MAX_PKT_LEN+500)
-
-    /* Since we don't have threads, log buffer can use static buffer */
-#   define PJ_LOG_USE_STACK_BUFFER	0
-
-	/* Disable check stack since it increases footprint */
-#   undef PJ_OS_HAS_CHECK_STACK
-#   define PJ_OS_HAS_CHECK_STACK	0
+    #define PJ_LOG_MAX_SIZE			(PJSIP_MAX_PKT_LEN+500)
+
+    /* Since we don't have threads, log buffer can use static buffer
+     * rather than stack
+     */
+    #define PJ_LOG_USE_STACK_BUFFER		0
+
+    /* Disable check stack since it increases footprint */
+    #define PJ_OS_HAS_CHECK_STACK		0
+
+
+    /*
+     * PJMEDIA settings
+     */
+
+    /* Disable non-Symbian audio devices */
+    #define PJMEDIA_AUDIO_DEV_HAS_PORTAUDIO	0
+    #define PJMEDIA_AUDIO_DEV_HAS_WMME		0
+
+    /* Select codecs to disable */
+    #define PJMEDIA_HAS_L16_CODEC		0
+    #define PJMEDIA_HAS_ILBC_CODEC		0
+    #define PJMEDIA_HAS_G722_CODEC		0
+
+    /* Fine tune Speex's default settings for best performance/quality */
+    #define PJMEDIA_CODEC_SPEEX_DEFAULT_QUALITY	5
+
+    /* For CPU reason, disable speex AEC and use the echo suppressor. */
+    #define PJMEDIA_HAS_SPEEX_AEC		0
+
+    /* Shouldn't use resampling for performance reason too. */
+    #define PJMEDIA_RESAMPLE_IMP		PJMEDIA_RESAMPLE_NONE
+
+    /* Use the lighter WSOLA implementation */
+    #define PJMEDIA_WSOLA_IMP			PJMEDIA_WSOLA_IMP_WSOLA_LITE
+
+    /* We probably need more buffers especially if MDA audio backend 
+     * is used, so increase the limit 
+     */
+    #define PJMEDIA_SOUND_BUFFER_COUNT		32
+
+    /*
+     * PJSIP settings.
+     */
+
+    /* Disable safe module access, since we don't use multithreading */
+    #define PJSIP_SAFE_MODULE			0
+
+    /* Increase allowable packet size, just in case */
+    #define PJSIP_MAX_PKT_LEN			2000
 
     /* Symbian has problem with too many large blocks */
-#   define PJSIP_POOL_LEN_ENDPT		1000
-#   define PJSIP_POOL_INC_ENDPT		1000
-#   define PJSIP_POOL_RDATA_LEN		2000
-#   define PJSIP_POOL_RDATA_INC		2000
-#   define PJSIP_POOL_LEN_TDATA		2000
-#   define PJSIP_POOL_INC_TDATA		512
-#   define PJSIP_POOL_LEN_UA		2000
-#   define PJSIP_POOL_INC_UA		1000
-#   define PJSIP_POOL_TSX_LAYER_LEN	256
-#   define PJSIP_POOL_TSX_LAYER_INC	256
-#   define PJSIP_POOL_TSX_LEN		512
-#   define PJSIP_POOL_TSX_INC		128
+    #define PJSIP_POOL_LEN_ENDPT		1000
+    #define PJSIP_POOL_INC_ENDPT		1000
+    #define PJSIP_POOL_RDATA_LEN		2000
+    #define PJSIP_POOL_RDATA_INC		2000
+    #define PJSIP_POOL_LEN_TDATA		2000
+    #define PJSIP_POOL_INC_TDATA		512
+    #define PJSIP_POOL_LEN_UA			2000
+    #define PJSIP_POOL_INC_UA			1000
+    #define PJSIP_POOL_TSX_LAYER_LEN		256
+    #define PJSIP_POOL_TSX_LAYER_INC		256
+    #define PJSIP_POOL_TSX_LEN			512
+    #define PJSIP_POOL_TSX_INC			128
+
+    /*
+     * PJSUA settings.
+     */
+
+    /* Default codec quality */
+    #define PJSUA_DEFAULT_CODEC_QUALITY		5
 
     /* Set maximum number of dialog/transaction/calls to minimum */
-#   define PJSIP_MAX_TSX_COUNT 		31
-#   define PJSIP_MAX_DIALOG_COUNT 	31
-#   define PJSUA_MAX_CALLS		4
+    #define PJSIP_MAX_TSX_COUNT 		31
+    #define PJSIP_MAX_DIALOG_COUNT 		31
+    #define PJSUA_MAX_CALLS			4
 
     /* Other pjsua settings */
-#   define PJSUA_MAX_ACC		4
-#   define PJSUA_MAX_PLAYERS		4
-#   define PJSUA_MAX_RECORDERS		4
-#   define PJSUA_MAX_CONF_PORTS		(PJSUA_MAX_CALLS+2*PJSUA_MAX_PLAYERS)
-#   define PJSUA_MAX_BUDDIES		32
-
-    /* Speex default quality settings */
-#   define PJSUA_DEFAULT_CODEC_QUALITY	5
-#   define PJMEDIA_CODEC_SPEEX_DEFAULT_QUALITY	5
+    #define PJSUA_MAX_ACC			4
+    #define PJSUA_MAX_PLAYERS			4
+    #define PJSUA_MAX_RECORDERS			4
+    #define PJSUA_MAX_CONF_PORTS		(PJSUA_MAX_CALLS+2*PJSUA_MAX_PLAYERS)
+    #define PJSUA_MAX_BUDDIES			32
+#endif
+
+
+/*
+ * Additional configuration to activate APS-Direct feature for
+ * Nokia S60 target
+ *
+ * Please see http://trac.pjsip.org/repos/wiki/Nokia_APS_VAS_Direct
+ */
+#ifdef PJ_CONFIG_NOKIA_APS_DIRECT
+
+    /* MUST use switchboard rather than the conference bridge */
+    #define PJMEDIA_CONF_USE_SWITCH_BOARD	1
+
+    /* Enable APS sound device backend and disable MDA */
+    #define PJMEDIA_AUDIO_DEV_HAS_SYMB_MDA	0
+    #define PJMEDIA_AUDIO_DEV_HAS_SYMB_APS	1
+
+    /* Enable passthrough codec framework */
+    #define PJMEDIA_HAS_PASSTHROUGH_CODECS	1
+
+    /* And selectively enable which codecs are supported by the handset */
+    #define PJMEDIA_HAS_PASSTHROUGH_CODEC_PCMU	1
+    #define PJMEDIA_HAS_PASSTHROUGH_CODEC_PCMA	1
+    #define PJMEDIA_HAS_PASSTHROUGH_CODEC_AMR	1
+    #define PJMEDIA_HAS_PASSTHROUGH_CODEC_G729	1
+    #define PJMEDIA_HAS_PASSTHROUGH_CODEC_ILBC	1
+
+#endif
+
+
+/*
+ * Configuration to activate "APS-Direct" media mode on Windows,
+ * useful for testing purposes only.
+ */
+#ifdef PJ_CONFIG_WIN32_WMME_DIRECT
+
+    /* MUST use switchboard rather than the conference bridge */
+    #define PJMEDIA_CONF_USE_SWITCH_BOARD	1
+
+    /* Only WMME supports the "direct" feature */
+    #define PJMEDIA_AUDIO_DEV_HAS_PORTAUDIO	0
+    #define PJMEDIA_AUDIO_DEV_HAS_WMME		1
+
+    /* Enable passthrough codec framework */
+    #define PJMEDIA_HAS_PASSTHROUGH_CODECS	1
+
+    /* Only PCMA and PCMU are supported by WMME-direct */
+    #define PJMEDIA_HAS_PASSTHROUGH_CODEC_PCMU	1
+    #define PJMEDIA_HAS_PASSTHROUGH_CODEC_PCMA	1
+    #define PJMEDIA_HAS_PASSTHROUGH_CODEC_AMR	0
+    #define PJMEDIA_HAS_PASSTHROUGH_CODEC_G729	0
+    #define PJMEDIA_HAS_PASSTHROUGH_CODEC_ILBC	0
+
 #endif
 
Index: pjproject/trunk/pjlib/include/pj/errno.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/errno.h	(revision 2505)
+++ pjproject/trunk/pjlib/include/pj/errno.h	(revision 2506)
@@ -376,4 +376,5 @@
  *  - PJLIB_UTIL_ERRNO_START	(PJ_ERRNO_START_USER + PJ_ERRNO_SPACE_SIZE*3)
  *  - PJNATH_ERRNO_START	(PJ_ERRNO_START_USER + PJ_ERRNO_SPACE_SIZE*4)
+ *  - PJMEDIA_AUDIODEV_ERRNO_START (PJ_ERRNO_START_USER + PJ_ERRNO_SPACE_SIZE*5)
  */
 
Index: pjproject/trunk/pjmedia/build/Makefile
===================================================================
--- pjproject/trunk/pjmedia/build/Makefile	(revision 2505)
+++ pjproject/trunk/pjmedia/build/Makefile	(revision 2506)
@@ -19,6 +19,6 @@
 export PJMEDIA_CODEC_LIB:=../lib/libpjmedia-codec-$(TARGET_NAME)$(LIBEXT)
 export PJSDP_LIB:=../lib/libpjsdp-$(TARGET_NAME)$(LIBEXT)
+export PJMEDIA_AUDIODEV_LIB:=../lib/libpjmedia-audiodev-$(TARGET_NAME)$(LIBEXT)
 
-NULLSOUND_OBJS := nullsound.o
 
 ###############################################################################
@@ -35,4 +35,5 @@
 		   $(HOST_CXXFLAGS) $(CXXFLAGS)
 export _LDFLAGS := $(subst /,$(HOST_PSEP),$(PJMEDIA_LIB)) \
+		   $(subst /,$(HOST_PSEP),$(PJMEDIA_AUDIODEV_LIB)) \
 		   $(subst /,$(HOST_PSEP),$(PJMEDIA_CODEC_LIB)) \
 		   $(subst /,$(HOST_PSEP),$(PJLIB_LIB)) \
@@ -50,19 +51,28 @@
 export PJMEDIA_OBJS += $(OS_OBJS) $(M_OBJS) $(CC_OBJS) $(HOST_OBJS) \
 			alaw_ulaw.o alaw_ulaw_table.o clock_thread.o codec.o \
-			conference.o delaybuf.o echo_common.o echo_port.o \
-			echo_suppress.o endpoint.o errno.o \
+			conference.o conf_switch.o delaybuf.o echo_common.o \
+			echo_port.o echo_suppress.o endpoint.o errno.o \
 			g711.o jbuf.o master_port.o mem_capture.o mem_player.o \
 			null_port.o plc_common.o port.o splitcomb.o \
 			resample_resample.o resample_libsamplerate.o \
 			resample_port.o rtcp.o rtcp_xr.o rtp.o \
-			sdp.o sdp_cmp.o sdp_neg.o \
-			session.o silencedet.o sound_port.o stereo_port.o \
+			sdp.o sdp_cmp.o sdp_neg.o session.o silencedet.o \
+			sound_legacy.o sound_port.o stereo_port.o \
 			stream.o tonegen.o transport_adapter_sample.o \
 			transport_ice.o transport_loop.o \
 			transport_srtp.o transport_udp.o \
 			wav_player.o wav_playlist.o wav_writer.o wave.o \
-			wsola.o $(SOUND_OBJS) $(NULLSOUND_OBJS)
+			wsola.o
 
 export PJMEDIA_CFLAGS += $(_CFLAGS)
+
+
+###############################################################################
+# Defines for building PJMEDIA-AUDIODEV library
+#
+export PJMEDIA_AUDIODEV_SRCDIR = ../src/pjmedia-audiodev
+export PJMEDIA_AUDIODEV_OBJS +=  audiodev.o audiotest.o errno.o legacy_dev.o pa_dev.o \
+				 wmme_dev.o
+export PJMEDIA_AUDIODEV_CFLAGS += $(_CFLAGS)
 
 
@@ -107,5 +117,5 @@
 # $(TARGET) is defined in os-$(OS_NAME).mak file in current directory.
 #
-TARGETS := pjmedia pjmedia-codec pjsdp pjmedia-test
+TARGETS := pjmedia pjmedia-audiodev pjmedia-codec pjsdp pjmedia-test
 
 all: $(TARGETS)
@@ -122,5 +132,5 @@
 distclean: realclean
 
-.PHONY: dep depend pjmedia pjmedia-codec pjmedia-test clean realclean distclean
+.PHONY: dep depend pjmedia pjmedia-codec pjmedia-audiodev pjmedia-test clean realclean distclean
 
 pjmedia:
@@ -129,4 +139,7 @@
 pjmedia-codec:
 	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA_CODEC app=pjmedia-codec $(PJMEDIA_CODEC_LIB)
+
+pjmedia-audiodev:
+	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA_AUDIODEV app=pjmedia-audiodev $(PJMEDIA_AUDIODEV_LIB)
 
 pjsdp:
@@ -153,4 +166,5 @@
 	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA app=pjmedia $@
 	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA_CODEC app=pjmedia-codec $@
+	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA_AUDIODEV app=pjmedia-audiodev $@
 	$(MAKE) -f $(RULES_MAK) APP=PJSDP app=pjsdp $@
 	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA_TEST app=pjmedia-test $@
@@ -158,4 +172,5 @@
 realclean:
 	$(subst @@,$(subst /,$(HOST_PSEP),.pjmedia-$(TARGET_NAME).depend),$(HOST_RMR))
+	$(subst @@,$(subst /,$(HOST_PSEP),.pjmedia-audiodev-$(TARGET_NAME).depend),$(HOST_RMR))
 	$(subst @@,$(subst /,$(HOST_PSEP),.pjmedia-codec-$(TARGET_NAME).depend),$(HOST_RMR))
 	$(subst @@,$(subst /,$(HOST_PSEP),.pjmedia-test-$(TARGET_NAME).depend),$(HOST_RMR))
@@ -163,4 +178,5 @@
 	
 	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA app=pjmedia $@
+	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA app=pjmedia-audiodev $@
 	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA_CODEC app=pjmedia-codec $@
 	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA_TEST app=pjmedia-test $@
@@ -169,4 +185,5 @@
 depend:
 	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA app=pjmedia $@
+	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA app=pjmedia-audiodev $@
 	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA_CODEC app=pjmedia-codec $@
 	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA_TEST app=pjmedia-test $@
